/* $Id: daemonize.c,v 1.6 2007/01/07 23:29:59 nanard Exp $ */
/* MiniUPnP project
 * http://miniupnp.free.fr/ or http://miniupnp.tuxfamily.org/
 * (c) 2006 Thomas Bernard 
 * This software is subject to the conditions detailed
 * in the LICENCE file provided within the distribution */

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>

#include "daemonize.h"

/* daemonize()
 * "fork" to background, detach from terminal, etc... */
int
daemonize(void)
{
	int pid, i;
	pid = fork();
	if(pid < 0)
	{
		perror("fork()");
		exit(1);
	}
	else if(pid > 0)
	{
		exit(0);
	}
	
	pid = setsid(); /* obtain a new process group */
	if(pid < 0)
	{
		perror("setsid()");
		exit(1);
	}
	
	for (i=getdtablesize();i>=0;--i) close(i); /* close all descriptors */

	i = open("/dev/null",O_RDWR); /* open stdin */
	dup(i); /* stdout */
	dup(i); /* stderr */

	umask(027);
	chdir("/"); /* chdir to /tmp ? */
	/* TODO : signals
	 * some signals are allready redirected in miniupnpd */
	
	return pid;
}

