#! /bin/sh
# $Id: genconfig.sh,v 1.4 2007/01/22 22:16:54 nanard Exp $
# miniupnp daemon
# http://miniupnp.free.fr or http://miniupnp.tuxfamily.org/
# (c) 2006 Thomas Bernard
# This software is subject to the conditions detailed in the
# LICENCE file provided within the distribution

RM="rm -f"
CONFIGFILE="config.h"
CONFIGMACRO="__CONFIG_H__"
OS_NAME=`uname -s`
OS_VERSION=`uname -r`

${RM} ${CONFIGFILE}

echo "/* MiniUPnP Project" >> ${CONFIGFILE}
echo " * http://miniupnp.free.fr/ or http://miniupnp.tuxfamily.org/" >> ${CONFIGFILE}
echo " * (c) 2006 Thomas Bernard" >> ${CONFIGFILE}
echo " * generated by $0 on `date` */" >> ${CONFIGFILE}
echo "#ifndef $CONFIGMACRO" >> ${CONFIGFILE}
echo "#define $CONFIGMACRO" >> ${CONFIGFILE}
echo "" >> ${CONFIGFILE}
echo -e "#define OS_NAME\t\"$OS_NAME\"" >> ${CONFIGFILE}
echo -e "#define OS_VERSION\t\"$OS_NAME/$OS_VERSION\"" >> ${CONFIGFILE}

# OS Specific stuff
case `uname -s` in
	OpenBSD)
		echo -e "#define OS_URL\t\"http://www.openbsd.org/\"" >> ${CONFIGFILE}
		MAJORVER=`echo $OS_VERSION | sed 's/\.[0-9]*//'`
		#echo "OpenBSD majorversion=$MAJORVER"
		# rtableid was introduced in OpenBSD 4.0
		if [ $MAJORVER -ge 4 ]; then
			echo "#define PFRULE_HAS_RTABLEID" >> ${CONFIGFILE}
		fi
		;;
	FreeBSD)
		echo -e "#define OS_URL\t\"http://www.freebsd.org/\"" >> ${CONFIGFILE}
		;;
	NetBSD)
		echo -e "#define OS_URL\t\"http://www.netbsd.org/\"" >> ${CONFIGFILE}
		;;
	Linux)
		echo -e "#define OS_URL\t\"http://www.kernel.org/\"" >> ${CONFIGFILE}
		;;
	*)
		echo "Unknown OS : $OS_NAME"
		echo "Please contact the author at http://miniupnp.free.fr/"
		exit 1
		;;
esac

echo "" >> ${CONFIGFILE}
echo "#endif" >> ${CONFIGFILE}

exit 0
