/* $Id: options.h,v 1.3 2007/01/30 17:08:46 nanard Exp $ */
/* MiniUPnP project
 * http://miniupnp.free.fr/ or http://miniupnp.tuxfamily.org/
 * author: Ryan Wagoner
 * (c) 2006 Thomas Bernard 
 * This software is subject to the conditions detailed
 * in the LICENCE file provided within the distribution */

#ifndef __OPTIONS_H__
#define __OPTIONS_H__

/* enum of option available in the miniupnpd.conf */
enum upnpconfigoptions {
	UPNP_INVALID = 0,
	UPNPEXT_IFNAME = 1,	/* ext_ifname */
	UPNPEXT_IP,			/* ext_ip */
	UPNPLISTENING_IP,	/* listening_ip */
	UPNPPORT,			/* "port" */
	UPNPBITRATE_UP,		/* "bitrate_up" */
	UPNPBITRATE_DOWN,	/* "bitrate_down" */
	UPNPPRESENTATIONURL,	/* presentation_url */
	UPNPNOTIFY_INTERVAL,	/* notify_interval */
	UPNPSYSTEM_UPTIME,	/* "system_uptime" */
	UPNPPACKET_LOG,		/* "system_uptime" */
	UPNPUUID			/* uuid */
};

int
readoptionsfile(const char * fname);

char * 
getoptionvalue(const char * name);

void
freeoptions(void);

/*#define MAX_OPTION_NAME_LEN	64*/
/*#define MAX_OPTION_VALUE_LEN	192*/
#define MAX_OPTION_VALUE_LEN	128
struct option
{
	enum upnpconfigoptions id;
	/*char name[MAX_OPTION_NAME_LEN];*/
	char value[MAX_OPTION_VALUE_LEN];
};

extern struct option * ary_options;
extern int num_options;

#endif

