/* $Id: upnppermissions.h,v 1.5 2007/01/28 17:44:07 nanard Exp $ */
/* MiniUPnP project
 * http://miniupnp.free.fr/ or http://miniupnp.tuxfamily.org/
 * (c) 2006 Thomas Bernard
 * This software is subject to the conditions detailed
 * in the LICENCE file provided within the distribution */

#ifndef __UPNPPERMISSIONS_H__
#define __UPNPPERMISSIONS_H__

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

/* UPnP Permission rule samples :
 * allow 1024-65535 192.168.3.0/24 1024-65535
 * deny 0-65535 192.168.1.125/32 0-65535 */
struct upnpperm {
	enum {UPNPPERM_ALLOW=1, UPNPPERM_DENY=2 } type;
				/* is it an allow or deny permission rule ? */
	u_short eport_min, eport_max;	/* external port range */
	struct in_addr address, mask;	/* ip/mask */
	u_short iport_min, iport_max;	/* internal port range */
};

int
read_permission_line(struct upnpperm * perm,
                     char * p);

/* check_upnp_rule_against_permissions() 
 * return FALSE if the upnp rule should be rejected,
 * or TRUE if it could be accepted */
int
check_upnp_rule_against_permissions(const struct upnpperm * permary,
                                    int n_perms,
                                    u_short eport, struct in_addr address,
                                    u_short iport);

#endif

